﻿using System;
using System.ComponentModel;

// http://www.codeproject.com/Articles/41817/Implementing-INotifyPropertyChanged
using log4net;
using log4net.Config;

namespace NotifyPropertyChangeSmallExample
{
    class Program
    {
        static void Main()
        {
            Student student = new Student();
            student.Name ="Anders";

            student.PropertyChanging += (sender, args) =>
                Console.WriteLine("Changing: " + sender);  
           
            student.PropertyChanged += WriteToScreen;
            student.Name = "John";
            
            BasicConfigurator.Configure(); 
                // configure logger, simple, no XML config file
            student.PropertyChanged += WriteToLog;
            student.Name = "John";
            //student.Age = 33;

            student.PropertyChanging += (sender, args) =>
            {
                PropertyChangingEventArgs2<String> args2 = args as PropertyChangingEventArgs2<String>;
                if (args2 == null)
                    Console.WriteLine("null");
                else
                {
                    Console.WriteLine(args2);
                }
            };
            student.Age = 100;
        }

        private static void WriteToScreen(Object sender, PropertyChangedEventArgs eventArgs)
        {
            Student st = sender as Student;
            if (st == null) return;
            switch (eventArgs.PropertyName)
            {
                case "Name": Console.WriteLine("new name: {0}", st.Name);
                    break;
                case "Age":
                    Console.WriteLine("new age: {0}", st.Age);
                    break;
                default:
                    Console.WriteLine("Strange property ... " + eventArgs.PropertyName);
                    break;
            }
        }

        private static readonly ILog MyLogger = LogManager.GetLogger("someName");

        private static void WriteToLog(object sender, PropertyChangedEventArgs args)
        {
            MyLogger.Info("Property changed: " + args.PropertyName);   
        }
    }
}
