﻿using System;
using System.ComponentModel;
using System.Runtime.CompilerServices;

// http://www.codeproject.com/Articles/41817/Implementing-INotifyPropertyChanged

namespace NotifyPropertyChangeSmallExample
{
    public class Student : INotifyPropertyChanged, INotifyPropertyChanging
    {
        private string _name;
        private int _age;

        public String Name
        {
            get { return _name; }
            set
            {
                if (_name == value) return;
                _name = value;
                OnPropertyChanged("Name");
            }
        }

        public int Age
        {
            get { return _age; }
            set
            {
                if (_age == value) return;
                OnPropertyChanging("Age");
                _age = value;
                OnPropertyChanged();
            }
        }

        public override string ToString()
        {
            return string.Format("Name: {0}", Name);
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged([CallerMemberName] String propertyName = "")
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        public event PropertyChangingEventHandler PropertyChanging;

        protected virtual void OnPropertyChanging([CallerMemberName] String propertyName = "")
        {
            PropertyChangingEventHandler handler = PropertyChanging;
            if (handler != null)
            {
                //handler(this, new PropertyChangingEventArgs(propertyName));
                handler(this, new PropertyChangingEventArgs2<String>(propertyName, "old", "new"));
            }
        }
    }
}
