﻿using System.ComponentModel;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using NotifyPropertyChangeSmallExample;

namespace NotifyPropertyChangeSmallExampleTests
{
    [TestClass]
    public class StudentTests
    {
        [TestMethod]
        public void ObserverTest()
        {
            Student student = new Student { Name = "John", Age = 23 };
            ObserverHelper observer = new ObserverHelper();
            Assert.IsNull(observer.Sender);
            Assert.IsNull(observer.Args);
            student.PropertyChanged += observer.Handler;
            student.Name = "Peter";
            Assert.AreEqual(student, observer.Sender);
            Assert.AreEqual("Name", observer.Args.PropertyName);
            student.Age = 24;
            Assert.AreEqual("Age", observer.Args.PropertyName);
        }
    }

    /// <summary>
    /// Simply saves the value of sender + PropertyChangedEventArgs
    /// so that the test can assert something about the values
    /// </summary>
    class ObserverHelper
    {
        public object Sender { get; set; }
        public PropertyChangedEventArgs Args { get; set; }
        public void Handler(object sender, PropertyChangedEventArgs args)
        {
            Sender = sender;
            Args = args;
        }
    }
}
